<?php

include_once(WPSITE_FIREBAR_PLUGIN_DIR . "/admin/model/db.php");
include_once(WPSITE_FIREBAR_PLUGIN_DIR . "/core/model/stats.php");

// Create Table if one does not exist

WPsite_Stats_FB::createTable();

// Get global settings

$global_settings = get_option(self::$prefix . 'global_settings');

if ( $global_settings === false ) {
	$global_settings = WPsite_Firebar_Admin_Functions::default_global_settings();
}

// Export data

if (isset($_GET['export_data']) && $_GET['export_data'] == 'true' && check_admin_referer(self::$prefix . 'export_data')) {

	$start_date = date(WPSITE_FIREBAR_DATE_FORMAT, mktime(0, 0, 0, date("m")-1, date("d"), date("Y")));
	$end_date = date(WPSITE_FIREBAR_DATE_FORMAT, strtotime(current_time('mysql')));

	if (isset($_GET[self::$prefix_dash . 'start-date']) && $_GET[self::$prefix_dash . 'start-date'] != '') {
		$start_date = date(WPSITE_FIREBAR_DATE_FORMAT, strtotime($_GET[self::$prefix_dash . 'start-date']));
	}

	if (isset($_GET[self::$prefix_dash . 'end-date']) && $_GET[self::$prefix_dash . 'end-date'] != '') {
		$end_date = date(WPSITE_FIREBAR_DATE_FORMAT, strtotime($_GET[self::$prefix_dash . 'end-date']));
	}

	global $wpdb;
	$firebar_stats = WPsite_Stats_FB::getStats($start_date, $end_date, $_GET['firebar_id']);
	$firebars = $wpdb->get_results("SELECT * FROM `" . WPsite_Firebar_DB::getTableName() . "`");

	foreach ($firebars as $firebar) {
		foreach ($firebar_stats as $key => $firebar_stat) {
			if ($firebar->id == $firebar_stat['firebar_id']) {
				$firebar_stats[$key] = array('firebar_name' => $firebar->name) + $firebar_stats[$key];

				if ($firebar->template == 'Text') {
					$firebar_stats[$key]['clicks'] = __('N/A', self::$prefix_dash);
					$firebar_stats[$key]['click-through-rate'] = __('N/A', self::$prefix_dash);
				} else {
					$firebar_stats[$key]['click-through-rate'] = round(($firebar_stats[$key]['clicks']/$firebar_stats[$key]['impressions']) * 100,2) . '%';
				}
			}
		}
	}

	// Unset indexes

	foreach ($firebar_stats as $key => $firebar_stat) {
		unset($firebar_stats[$key]['id']);
		unset($firebar_stats[$key]['firebar_id']);
	}

	$filename =  self::$prefix . 'stats.csv';
	$export_file = fopen(WPSITE_FIREBAR_PLUGIN_DIR . '/exports/' . $filename, "w");
	fputcsv($export_file, array('Firebar Name', 'Date', 'Impressions', 'Clicks', 'Click-Through-Rate'));

	foreach (array_reverse($firebar_stats) as $firebar_stat) {
	    fputcsv($export_file, $firebar_stat);
	}

	fclose($export_file);

	?>
	<script type="text/javascript">
		window.location = '<?php echo WPSITE_FIREBAR_PLUGIN_URL . '/exports/download.php?filename=' . $filename; ?>';
	</script>
	<?php
}

wp_enqueue_script(self::$prefix . 'stats_js', WPSITE_FIREBAR_PLUGIN_URL . '/admin/js/stats.js', array('jquery'));
wp_localize_script(self::$prefix . 'stats_js', 'wps_fb_stats_data', array(
	'prefix_dash' 		=> self::$prefix_dash,
	'today'				=> date('m/d/Y')
));

include_once(WPSITE_FIREBAR_PLUGIN_DIR . '/admin/views/stats.php');